package RFC::Prototype::253;

package UNIVERSAL;   

sub require {     
    my($module, $want_version) = @_;
 
    die("UNIVERSAL::require() can only be run as a class method")  
      if ref $module; 
 
    die("UNIVERSAL::require() takes no or one arguments") if @_ > 2; 
    
    # Load the module.
    my $return = eval "CORE::require $module";
    
    # Check for module load failure.
    if( $@ ) {
        $@ =~ s/ at .*?\n$//;
        die sprintf "$@ at %s line %d.\n", (caller)[1,2];
    }
    
    # Module version check.  We can't just call UNIVERSAL->VERSION
    # and let it die because the file and line numbers will be wrong.
    if( @_ == 2 and !eval { $module->VERSION($want_version); 1 } ) {
        $@ =~ s/ at .*?\n$//;
        die sprintf "$@ at %s line %d\n", (caller)[1,2];
    }

    return $return;   
} 


1;
